# YASARA PLUGIN

# TOPIC:       Agadir predictions

# TITLE:       Agadirwrapper plugin

# AUTHOR:      GREET DE BAETS. VIB Switch Laboratory, Leuvenf, Belgium

# LICENSE:     GPL (www.gnu.org)

# DESCRIPTION: This plugin provides access to various tools from the agadirwrapper, like Tango, Waltz, Limbo,... in YASARA. 

# This is a YASARA plugin to be placed in the /plg subdirectory

# Go to www.yasara.org/plugins for documentation and downloads
#
# 
"""
MainMenu: Analyze
  PullDownMenu after Energy: Solubis
    PopUpMenu: Complete analysis of Object
      ObjectSelectionMenu: Select the object(s) for analysis
      CheckBoxMenu2: Select aggregation predictors
        Text: Select aggregation predictors
        Text: Tango (Checked)
      NumberInputMenu6: Set Tango options (1)
        Text: Set values for Tango options (default is shown):
        Number: Temperature (K),298,0,500
        Number: pH,7.5,1,14
        Number: IonStrength, 0.150,0,10
        Number: TfeConc, 0,0,5
        Number: Stability, 0,0,5
        Number: Concentration, 1,1,5
      NumberInputMenu3: Set Tango options (2)
        Text: Set values for Tango options (default is shown):
        Number: Tango window treshold,5,1,100
        Number: Minimum Tango Window size,5,5,50
        Number: Tango Flank size,3,0,5
      SwitchBoxMenu2: Choose visualization (1)
        Text: How do you want to visualize the zones?
        Text: Merge all analyses in current object
        Text: Create new object per analysis
      SwitchBoxMenu2: Choose visualization (2)
        Text: How do you want to color the zones?
        Text: All same color
        Text: Color gradient by aggregation tendency
      CustomWindow: Information about the alignment file
        Width: 600
        Height: 400
        Text: X=30, Y=58, "If you structure contains a gap, it is necessary to provide"
        Text: X=30, Y=88, "us with an alignment file. This file consists of 2 lines for each molecule:"
        Text: X=30, Y=138, "*the first line = The name (ObjXMolY), followed by the exact sequence"
        Text: X=50, Y=158, " in the PDB (separated by a tab), "
        Text: X=30, Y=188, "*the second line = the name (ObjXMolY, followed by the exact sequence"
        Text: X=50, Y=208, "with the gaps (separated by a tab), "
        Checkbox: X=60, Y=258, "Toggle this checkbox if it contains gaps.",Default=No
        Text: X=30, Y=318, "If your structure does nog contain gaps, just press OK and continue."
        Button: X=542, Y=348, Text="_O_K"
      FileSelectionMenu: Select alignment file if this object contains a gap
        MultipleSelections: No
        Filename: *
      Request: RunAgadir
      
    PopUpMenu: Complete analysis of a Molecule
      MoleculeSelectionMenu: Select the molecule(s) for analysis
      CheckBoxMenu2: Select aggregation predictors
        Text: Select aggregation predictors
        Text: Tango (Checked)
      NumberInputMenu6: Set Tango options (1)
        Text: Set values for Tango options (default is shown):
        Number: Temperature (K),298,0,500
        Number: pH,7.5,1,14
        Number: IonStrength, 0.150,0,10
        Number: TfeConc, 0,0,5
        Number: Stability, 0,0,5
        Number: Concentration, 1,1,5
      NumberInputMenu3: Set Tango options (2)
        Text: Set values for Tango options (default is shown):
        Number: Tango window treshold,5,1,100
        Number: Minimum Tango Window size,5,5,50
        Number: Tango Flank size,3,0,5
      SwitchBoxMenu2: Choose visualization (1)
        Text: How do you want to visualize the zones?
        Text: Merge all analyses in current object
        Text: Create new object per analysis
      SwitchBoxMenu2: Choose visualization (2)
        Text: How do you want to color the zones?
        Text: All same color
        Text: Color gradient by aggregation tendency
      CustomWindow: Information about the alignment file
        Width: 600
        Height: 400
        Text: X=30, Y=58, "If you structure contains a gap, it is necessary to provide"
        Text: X=30, Y=88, "us with an alignment file. This file consists of 2 lines for each molecule:"
        Text: X=30, Y=138, "*the first line = The name (ObjXMolY), followed by the exact sequence"
        Text: X=50, Y=158, " in the PDB (separated by a tab), "
        Text: X=30, Y=188, "*the second line = the name (ObjXMolY, followed by the exact sequence"
        Text: X=50, Y=208, "with the gaps (separated by a tab), "
        Checkbox: X=60, Y=258, "Toggle this checkbox if it contains gaps.",Default=No
        Text: X=30, Y=318, "If your structure does nog contain gaps, just press OK and continue."
        Button: X=542, Y=348, Text="_O_K"
      FileSelectionMenu: Select alignment file if this object contains a gap
        MultipleSelections: No
        Filename: *
      Request: RunAgadirMol

    PopUpMenu: Mutate Residue
      ResidueSelectionMenu: Select a residue for mutation
      ListMenu: Select new amino acid residue(s)
        MultipleSelections: Yes
        Text: Select new amino acid(s)
        TextFile: solubisaminoacids.txt
      CheckBoxMenu2: Select aggregation predictors
        Text: Select aggregation predictors
        Text: Tango (Checked)
      NumberInputMenu6: Set Tango options (1)
        Text: Set values for Tango options (default is shown):
        Number: Temperature (K),298,0,500
        Number: pH,7.5,1,14
        Number: IonStrength, 0.150,0,10
        Number: TfeConc, 0,0,5
        Number: Stability, 0,0,5
        Number: Concentration, 1,1,5
      NumberInputMenu3: Set Tango options (2)
        Text: Set values for Tango options (default is shown):
        Number: Tango window treshold,5,1,100
        Number: Minimum Tango Window size,5,5,50
        Number: Tango Flank size,3,0,5
      CustomWindow: Information about the alignment file
        Width: 600
        Height: 400
        Text: X=30, Y=58, "If you structure contains a gap, it is necessary to provide"
        Text: X=30, Y=88, "us with an alignment file. This file consists of 2 lines for each molecule:"
        Text: X=30, Y=138, "*the first line = The name (ObjXMolY), followed by the exact sequence"
        Text: X=50, Y=158, " in the PDB (separated by a tab), "
        Text: X=30, Y=188, "*the second line = the name (ObjXMolY, followed by the exact sequence"
        Text: X=50, Y=208, "with the gaps (separated by a tab), "
        Checkbox: X=60, Y=258, "Toggle this checkbox if it contains gaps.",Default=No
        Text: X=30, Y=318, "If your structure does nog contain gaps, just press OK and continue."
        Button: X=542, Y=348, Text="_O_K"
      FileSelectionMenu: Select alignment file if this object contains a gap
        MultipleSelections: No
        Filename: *
      Request: MutateRes

    PopUpMenu: Solubis run on complete molecule
      MoleculeSelectionMenu: Select the molecule for analysis
      NumberInputMenu6: Set Tango options (1)
        Text: Set values for Tango options (default is shown):
        Number: Temperature (K),298,0,500
        Number: pH,7.5,1,14
        Number: IonStrength, 0.150,0,10
        Number: TfeConc, 0,0,5
        Number: Stability, 0,0,5
        Number: Concentration, 1,1,5
      NumberInputMenu3: Set Tango options (2)
        Text: Set values for Tango options (default is shown):
        Number: Tango window treshold,5,1,100
        Number: Minimum Tango Window size,5,5,50
        Number: Tango Flank size,3,0,5
      CheckBoxMenu2: Select FoldX routines
        Text: Select FoldX actions
        Text: FoldX RepairPDB
        Text: Calculate Stability change (Checked)
      NumberInputMenu5: Set FoldX options (Only if you want to calculate Stability change)
        Text: Set values for FoldX options (default is shown):
        Number: Number of runs,3,1,5
        Number: Temperature (K),298,0,500
        Number: pH,7,1,14
        Number: Ionic strength (x100),5,0,10
        Number: VdW design,0,0,2
      NumberInputMenu2: Treshold TANGO / FOLDX
        Text: Treshold for aggregation tendency and stability?
        Number: Treshold aggregation,100,0,5000
        Number: Treshold stability (if calculated),-0.5,-5,0
      NumberInputMenu1: Number of mutations
        Text: Set how many mutations you want to retrieve
        Number: Number of Mutations,1,1,5
      CustomWindow: Information about the alignment file
        Width: 600
        Height: 400
        Text: X=30, Y=58, "If you structure contains a gap, it is necessary to provide"
        Text: X=30, Y=88, "us with an alignment file. This file consists of 2 lines for each molecule:"
        Text: X=30, Y=138, "*the first line = The name (ObjXMolY), followed by the exact sequence"
        Text: X=50, Y=158, " in the PDB (separated by a tab), "
        Text: X=30, Y=188, "*the second line = the name (ObjXMolY, followed by the exact sequence"
        Text: X=50, Y=208, "with the gaps (separated by a tab), "
        Checkbox: X=60, Y=258, "Toggle this checkbox if it contains gaps.",Default=No
        Text: X=30, Y=318, "If your structure does nog contain gaps, just press OK and continue."
        Button: X=542, Y=348, Text="_O_K"
      FileSelectionMenu: Select alignment file if this object contains a gap
        MultipleSelections: No
        Filename: *
      Request: LowerMutEnergy

    PopUpMenu: Solubis run in marked region
      ResidueSelectionMenu: Select residue(s) that you want to analyze with Solubis
      NumberInputMenu6: Set Tango options (1)
        Text: Set values for Tango options (default is shown):
        Number: Temperature (K),298,0,500
        Number: pH,7.5,1,14
        Number: IonStrength, 0.150,0,10
        Number: TfeConc, 0,0,5
        Number: Stability, 0,0,5
        Number: Concentration, 1,1,5
      NumberInputMenu3: Set Tango options (2)
        Text: Set values for Tango options (default is shown):
        Number: Tango window treshold,5,1,100
        Number: Minimum Tango Window size,5,5,50
        Number: Tango Flank size,3,0,5
      CheckBoxMenu2: Select FoldX routines
        Text: Select FoldX actions
        Text: FoldX RepairPDB
        Text: Calculate Stability change (Checked)
      NumberInputMenu5: Set FoldX options (Only if you want to calculate Stability change)
        Text: Set values for FoldX options (default is shown):
        Number: Number of runs,3,1,5
        Number: Temperature (K),298,0,500
        Number: pH,7,1,14
        Number: Ionic strength (x100),5,0,10
        Number: VdW design,0,0,2
      NumberInputMenu2: Treshold TANGO / FOLDX
        Text: Treshold for aggregation tendency and stability?
        Number: Treshold aggregation,100,0,5000
        Number: Treshold stability (if calculated),-0.5,-5,0
      NumberInputMenu1: Number of mutations
        Text: Set how many mutations you want to retrieve
        Number: Number of Mutations,1,1,5
      CustomWindow: Information about the alignment file
        Width: 600
        Height: 400
        Text: X=30, Y=58, "If you structure contains a gap, it is necessary to provide"
        Text: X=30, Y=88, "us with an alignment file. This file consists of 2 lines for each molecule:"
        Text: X=30, Y=138, "*the first line = The name (ObjXMolY), followed by the exact sequence"
        Text: X=50, Y=158, " in the PDB (separated by a tab), "
        Text: X=30, Y=188, "*the second line = the name (ObjXMolY, followed by the exact sequence"
        Text: X=50, Y=208, "with the gaps (separated by a tab), "
        Checkbox: X=60, Y=258, "Toggle this checkbox if it contains gaps.",Default=No
        Text: X=30, Y=318, "If your structure does nog contain gaps, just press OK and continue."
        Button: X=542, Y=348, Text="_O_K"
      FileSelectionMenu: Select alignment file if this object contains a gap
        MultipleSelections: No
        Filename: *
      Request: MarkRegion

    PopUpMenu: Save last calculation
      SwitchBoxMenu2: Save files
        Text: Do you want to save all output files?
        Text: Yes, everything please
        Text: No, just SUMMARY file
      FileSelectionMenu: Select a folder and/or filename prefix to save files
        MultipleSelections: No
        Filename: *
      Request: SaveCalc

    PopUpMenu: Configure plugin
      FileSelectionMenu: Select your Tango executable file
        MultipleSelections: No
        Filename: *
      FileSelectionMenu: Select your FoldX executable file
        MultipleSelections: No
        Filename: *
      FileSelectionMenu: Select your FoldX rotabase.txt file
        MultipleSelections: No
        Filename: *
      Request: FileLocations

"""

#!/usr/bin/python

import yasara,string,disk,os,glob,subprocess
#import string,os
import solubis_run,solubisplotoutput,solubis_mutateres,solubis_main,solubis_foldx
from python2to3 import *
 
# amino acid residue list
aas = ['A','C','D','E','F','G','H','I','K','L','M','N','P','Q','R','S','T','V','W','Y']
# residue conversion dictionnary
aa_dict = {'ALA':'A','CYS':'C','ASP':'D','GLU':'E','PHE':'F','GLY':'G','HIS':'H','ILE':'I','LYS':'K','LEU':'L','MET':'M','ASN':'N','PRO':'P','GLN':'Q','ARG':'R','SER':'S','THR':'T','VAL':'V','TRP':'W','TYR':'Y','H1S':'H','H2S':'H'}
aa_dict_2 = dict((v,k) for k, v in aa_dict.items())

# set non-calculation requests so we don't clean the cache folder after these. 
noncalc =['SaveCalc']

# Main program
# ============

#check if operating system is OK, otherwise disable the plugin
if (yasara.request=="CheckIfDisabled"):
  # ASSIGN A 1 TO yasara.plugin.exitcode IF THIS PLUGIN CANNOT WORK AND SHOULD
  # BE DISABLED (DATA MISSING, WRONG OPERATING SYSTEM ETC.)
  # check operating system
  yasara.plugin.exitcode=0

# *************************************************************************************************************************************
# * set file locations of TANGO binary, this section needs to be the first one, otherwise even this section will raise an error at the end *
# *************************************************************************************************************************************
elif (yasara.request=="FileLocations"):
#set path to agadir
  agadirbinpath = yasara.selection[0].filename[0]
  foldxbinpath = yasara.selection[1].filename[0]
  rotabasepath = yasara.selection[2].filename[0]
  lines = open("solubis.cnf","r").readlines()
  output = open("solubis.cnf","w")
  for line in lines:
    if line[0:10] == "AGADIR_BIN":
      output.write("AGADIR_BIN = "+agadirbinpath+"\n")
    elif line[0:9] == "FOLDX_BIN":
      output.write("FOLDX_BIN = "+foldxbinpath+"\n")
    elif line[0:14] == "FOLDX_ROTABASE":
      output.write("FOLDX_ROTABASE = "+rotabasepath+"\n\n")
    else:
      output.write(line)
  output.close()

# continue if OK, do some basic initializing
else:
  # check for path of agadir binary
  if not os.path.exists(yasara.plugin.config["AGADIR_BIN"]):
    yasara.plugin.end("Cannot locate the tango executable file. Please click Analyze > Solubis > Configure Plugin to select the tango executable file.")
  # check if foldx is defined when picking request LowerMutEnergy
  if (yasara.request=="LowerMutEnergy" or yasara.request=="MarkRegion"):
    # if not os.path.split(yasara.plugin.config["FOLDX_ROTABASE"])[-1]=='rotabase.txt':
    #   yasara.plugin.end("Cannot locate the FoldX rotabase file. Please click Analyze >AgadirWrapper > Configure Plugin for FoldX to select the FoldX executable file.")
    if not os.path.exists(yasara.plugin.config["FOLDX_BIN"]):
      yasara.plugin.end("Cannot locate the FoldX executable file. Please click Analyze > Solubis > Configure Plugin for FoldX to select the FoldX executable file.")

  # hide Console for speed gain
  yasara.Console("Hidden")
  # set the cache dir
  cachedir = os.path.join(os.getcwd(),yasara.plugin.config["AGADIR_TMP"])
  #delete temp folder
  if yasara.request not in noncalc:
    disk.rmdir(cachedir)
  # make the cachedir
  if (not os.path.exists(cachedir)): disk.makedirs(cachedir,yasara.permissions)
  # get the agadir executable absolute path and put double quotes around it to handle paths with spaces
  agadirbin='"'+yasara.plugin.config["AGADIR_BIN"]+'"'
  if (yasara.request == "LowerMutEnergy" or yasara.request=="MarkRegion" or yasara.request=="solubis_gap"):
    # get the foldx executable absolute path and put double quotes around it to handle paths with spaces
    foldxbin='"'+yasara.plugin.config["FOLDX_BIN"]+'"'
    # copy the rotabase file to the cachedir
    disk.copy(yasara.plugin.config["FOLDX_ROTABASE"],os.path.join(cachedir,"rotabase.txt"))
# ****************************
# * Run AgadirWrapper_Object *
# ****************************

if(yasara.request=="RunAgadir"):
  yasara.Console("Hidden")
  yasara.DelWaterAll() #delete all the water otherwise also in sequencefile
  yasara.NameRes("H1s H2s","HIS")

  ## initialize PDB MAP+other parameters
  oldtonew={}
  newtoold={}
  provided_pdb_seq={}
  pdbseq_dashgaps={}
  pdbseq_filledgaps={}
  gap_map={}
  count_gap_seq=0

  #define fasta file
  output_fasta = open(os.path.join(cachedir,"all_seq.fa"),"w")
  output_tab = open(os.path.join(cachedir,"all_seq.tab"),"w")

  #which parameters did you give in?
  temperature = yasara.selection[2].number[0]
  ph = yasara.selection[2].number[1]
  ionicstrength = yasara.selection[2].number[2]
  TfeConc = yasara.selection[2].number[3]
  stability = yasara.selection[2].number[4]
  concentration = yasara.selection[2].number[5]
  tangowintresh = yasara.selection[3].number[0]
  tangominsize = yasara.selection[3].number[1]
  tangoflanksize = yasara.selection[3].number[2]

  #which visualization do you want: new object or vis on current object
  visual=yasara.selection[4].switchbox

  #which coloring?
  coloring=yasara.selection[5].switchbox

  # check if there is a gap in the structure
  gapflag=0
  if yasara.selection[6].checkbox[0] == 1:
    gapflag=1
    aln_file=yasara.selection[7].filename[0]
    f=open(aln_file,"r")
    count_names={}
    count=0
    
    for line in f:
      line=line.rstrip()
      count+=1
      field=line.split('\t')
      if(len(field)!=2):
        yasara.plugin.end("The alignment file is not correct. The name and sequence should be seperated with a tab.")
      if field[0] in count_names:
        count_names[field[0]]+=1
      else:
        count_names[field[0]]=0
        count_names[field[0]]+=1

      if "-" in field[1]:
        provided_pdb_seq[field[0]]=field[1].rstrip()
        provided_pdb_seq[field[0]]=provided_pdb_seq[field[0]].replace("-","")
        pdbseq_dashgaps[field[0]]=field[1].rstrip()
      else:
        pdbseq_filledgaps[field[0]]=field[1].rstrip()
    for key in count_names:
      if count_names[key]!=2:
        yasara.plugin.end("The alignment file is not correct. There should be 2 lines present for each molecule with gaps, in the correct format")

  #indicate whether it's Molecule or object level
  flagmolobj=0

  #Run over different objects and molecules and write seq in fasta file
  objcount= yasara.selection[0].objects

  for i in range(objcount):
    objectnumber = yasara.selection[0].object[i].number.inyas
    objectname = yasara.selection[0].object[i].name

    mollist = yasara.ListMol("Obj "+objectnumber+" AminoAcid","MOLNAME")
    ## CHECK IF NOT THE SAME MOLECULE NAMES => OTHERWISE HAVE TO CHANGE IT!!!
    molnames=set()
    for x,y in enumerate(mollist):
      if y in molnames:
        yasara.plugin.end("To calculate, all molecules in the object should have unique names. Please rename all nameless molecules with Edit > Rename")
      else:
        molnames.add(y)

    if visual==0:
      yasara.Style("Ribbon") 
      yasara.ColorObj(objectnumber,"gray")

    sequences=yasara.SequenceMol('Obj '+objectnumber+" Aminoacid")

    for x in molnames:
        if x is ' ':
          yasara.plugin.end("This object contains a molecule with no name (_). Please rename all nameless molecules with Edit > Rename")

        sequence=yasara.SequenceMol(x+' Obj '+objectnumber+" Protein")
        item=sequence[0]

        flag=item.islower()
        if not flag:
          name="Obj"+objectnumber+"Mol"+x
          if gapflag==0:
            pdbseq_filledgaps[name]=item
            pdbseq_dashgaps[name]=item
            provided_pdb_seq[name]=item
          if gapflag==1 and name in provided_pdb_seq:
            count_gap_seq+=1
          if gapflag==1 and name not in provided_pdb_seq:
            pdbseq_filledgaps[name]=item
            pdbseq_dashgaps[name]=item
            provided_pdb_seq[name]=item

          if gapflag==1 and item!=provided_pdb_seq[name]:
            yasara.plugin.end("The PDB sequence provided in the alignment file for "+name+" is not correct. Make sure that these are identical")

          output_fasta.write(">"+name+"\n")
          output_fasta.write(pdbseq_filledgaps[name]+"\n")
          output_tab.write(name+'\t'+pdbseq_filledgaps[name]+"\n")

          oldtonew[name]={}
          newtoold[name]={}
          residues=yasara.ListRes("Obj "+objectnumber+" Mol "+x,"format=RESNUM")
          count=0
          for x in residues:
            count=count+1
            data=x.split('=')
            oldtonew[name][data[1]]=count
            newtoold[name][count]=data[1]

          ## Loop first over alignment file to see where there are gaps
          res_nr=0
          res_nr_pdb=0
          gap_map[name]={}
          for x in pdbseq_filledgaps[name]:
            if x!=pdbseq_dashgaps[name][res_nr]:
              gap_map[name][res_nr]="N.A."
            else:
              gap_map[name][res_nr]=res_nr_pdb
              pdbnumber=newtoold[name][res_nr_pdb+1]
              res_nr_pdb+=1
              
            res_nr+=1

  output_fasta.close()
  output_tab.close()

  if gapflag==1 and count_gap_seq==0:
    yasara.plugin.end("You toggled the checkbox indicating that your sequence contains gaps. However, your alignment file does not contain an identifier matching the molecules you selected")
  if len(open(os.path.join(cachedir,"all_seq.fa")).readlines())<1:
    yasara.plugin.end("This is a non-protein. Impossible to calculate aggregation tendency.")

  #initialise array with stretches for Tango,waltz and limbo zones=> possible to color combinations of Tango&Waltz;...
  tango_array=[]

  #initialise output file which shows stretches for all wanted predictions
  output=""

  #which predictor?
  yasara.ShowMessage("Algorithms are running. Wait a moment please.")

  #Tango
  if(yasara.selection[1].checkbox[0] == 1):
    tango = 1
    (tango_array,output)=solubis_run.RunAgadirTango(agadirbin,cachedir,temperature,ph,ionicstrength,TfeConc,stability,concentration,tangowintresh,tangominsize,tangoflanksize,tango_array,output,visual,coloring,objectnumber,flagmolobj,newtoold,gapflag,gap_map)
  else:
    tango = 0

  yasara.HideMessage()

  # if there were stretches present, output them
  if output != "":
    solubisplotoutput.write_outputfile(cachedir,output)  
    yasara.write(output)
  
  yasara.Console("Open")
  yasara.plugin.end()


# ****************************
# * Run AgadirWrapper_Molecule *
# ****************************

elif(yasara.request=="RunAgadirMol"):
  yasara.Console("Hidden")
  yasara.DelWaterAll()
  yasara.NameRes("H1s H2s","HIS")

  ## open files to write to
  output_fasta = open(os.path.join(cachedir,"all_seq.fa"),"w")
  output_tab = open(os.path.join(cachedir,"all_seq.tab"),"w")

  #which parameters?
  temperature = yasara.selection[2].number[0]
  ph = yasara.selection[2].number[1]
  ionicstrength = yasara.selection[2].number[2]
  TfeConc = yasara.selection[2].number[3]
  stability = yasara.selection[2].number[4]
  concentration = yasara.selection[2].number[5]
  tangowintresh = yasara.selection[3].number[0]
  tangominsize = yasara.selection[3].number[1]
  tangoflanksize = yasara.selection[3].number[2]

  ## initialize PDB MAP+other parameters
  oldtonew={}
  newtoold={}
  provided_pdb_seq={}
  pdbseq_dashgaps={}
  pdbseq_filledgaps={}
  gap_map={}
  count_gap_seq=0

  #which visualization?

  visual=yasara.selection[4].switchbox

  #which coloring?
  coloring=yasara.selection[5].switchbox

  # check if there is a gap in the structure
  gapflag=0
  if yasara.selection[6].checkbox[0] == 1:
    gapflag=1
    aln_file=yasara.selection[7].filename[0]
    f=open(aln_file,"r")
    count_names={}
    count=0
    
    for line in f:
      line=line.rstrip()
      count+=1
      field=line.split('\t')

      if(len(field)!=2):
        yasara.plugin.end("The alignment file is not correct. The name and sequence should be seperated with a tab.")
      
      if field[0] in count_names:
        count_names[field[0]]+=1
      else:
        count_names[field[0]]=0
        count_names[field[0]]+=1

      if "-" in field[1]:
        provided_pdb_seq[field[0]]=field[1].rstrip()
        provided_pdb_seq[field[0]]=provided_pdb_seq[field[0]].replace("-","")
        pdbseq_dashgaps[field[0]]=field[1].rstrip()

      else:
        pdbseq_filledgaps[field[0]]=field[1].rstrip()
    for key in count_names:
      if count_names[key]!=2:
        yasara.plugin.end("The alignment file is not correct. There should be 2 lines present for each molecule with gaps, in the correct format")


  #indicate whether it's Molecule or object level
  flagmolobj=1

  #Run over different objects and molecules
  molcount= yasara.selection[0].molecules

  ## check if not double names
  molnames=set()

  for i in range(molcount):
	# objectnumber=yasara.selection[0].molecule[i].object.number
    molnumber = yasara.selection[0].molecule[i].number.inyas
    molname = yasara.selection[0].molecule[i].name
    if molname in molnames:
      yasara.plugin.end("To calculate, all molecules in the object should have unique names. Please rename all nameless molecules with Edit > Rename")
    else:
      molnames.add(molname)

    molecule = yasara.selection[0].molecule[i]
    if molname is ' ':
      yasara.plugin.end("This object contains a molecule with no name (_). Please rename all nameless molecules with Edit > Rename")
      
    objectnumber = molecule.object.number.inyas
    if visual==0:
      yasara.Style("Ribbon")
      yasara.ColorMol(molname,"gray")
    sequence = yasara.SequenceMol(molname+' Obj '+objectnumber)

    name="Obj"+objectnumber+"Mol"+molname

    ##if pdbseq does not contain gaps, make dictionary with original pdbseq
    if gapflag==1 and name in provided_pdb_seq:
      count_gap_seq+=1

    if gapflag==0:
      pdbseq_filledgaps[name]=sequence[0]
      pdbseq_dashgaps[name]=sequence[0]
      provided_pdb_seq[name]=sequence[0]

    if gapflag==1 and name not in provided_pdb_seq:
      pdbseq_filledgaps[name]=sequence[0]
      pdbseq_dashgaps[name]=sequence[0]
      provided_pdb_seq[name]=sequence[0]

    if gapflag==1 and sequence[0]!=provided_pdb_seq[name]:
      yasara.plugin.end("The PDB sequence provided in the alignment file for "+name+" is not correct. Make sure that these are identical")

    output_fasta.write(">Obj"+objectnumber+"Mol"+molname+"\n")
    output_fasta.write(pdbseq_filledgaps[name]+"\n")
    output_tab.write("Obj"+objectnumber+"Mol"+molname+"\t"+pdbseq_filledgaps[name]+"\n")

    oldtonew[name]={}
    newtoold[name]={}
    residues=yasara.ListRes("Obj "+objectnumber+" Mol "+molname,"format=RESNUM")
    count=0
    for x in residues:
      count=count+1
      data=x.split('=')
      oldtonew[name][data[1]]=count
      newtoold[name][count]=data[1]

	## Loop first over alignment file to see where there are gaps
    res_nr=0
    res_nr_pdb=0
    gap_map[name]={}
    for x in pdbseq_filledgaps[name]:
      if x!=pdbseq_dashgaps[name][res_nr]:
        gap_map[name][res_nr]="N.A."

      else:
        gap_map[name][res_nr]=res_nr_pdb
        pdbnumber=newtoold[name][res_nr_pdb+1]
        res_nr_pdb+=1
      res_nr+=1

  if gapflag==1 and count_gap_seq==0:
    yasara.plugin.end("You toggled the checkbox indicating that your sequence contains gaps. However, your alignment file does not contain an identifier matching the molecules you selected")

  output_fasta.close()
  output_tab.close()   

  # ********************************
  ##Read in the Options + Run Agadir
  # ********************************
  tango_array=[]

  output=""

  yasara.ShowMessage("Algorithms are running. Wait a moment please.")
  if(yasara.selection[1].checkbox[0] == 1):
    tango = 1
    (tango_array,output)=solubis_run.RunAgadirTango(agadirbin,cachedir,temperature,ph,ionicstrength,TfeConc,stability,concentration,tangowintresh,tangominsize,tangoflanksize,tango_array,output,visual,coloring,objectnumber,flagmolobj,newtoold,gapflag,gap_map)
  else:
    tango = 0

  yasara.HideMessage()
  # if there were stretches present, output them
  if output != "":
    solubisplotoutput.write_outputfile(cachedir,output)    
    yasara.write(output)
  
  yasara.Console("Open")
  yasara.plugin.end()

elif(yasara.request=="MutateRes"):
  yasara.ShowMessage("Algorithms are running. Wait a moment please.")
  yasara.Console("Hidden")
  yasara.DelWaterAll()
  yasara.NameRes("H1s H2s","HIS")

  ## initialize PDB MAP+other parameters
  oldtonew={}
  newtoold={}
  provided_pdb_seq={}
  pdbseq_dashgaps={}
  pdbseq_filledgaps={}
  gap_map={}
  gap_map_inverse={}
  count_gap_seq=0
  seq={}
  #which parameters?
  temperature = yasara.selection[3].number[0]
  ph = yasara.selection[3].number[1]
  ionicstrength = yasara.selection[3].number[2]
  TfeConc = yasara.selection[3].number[3]
  stability = yasara.selection[3].number[4]
  concentration = yasara.selection[3].number[5]
  tangowintresh = yasara.selection[4].number[0]
  tangominsize = yasara.selection[4].number[1]
  tangoflanksize = yasara.selection[4].number[2]

  # check if there is a gap in the structure
  gapflag=0
  if yasara.selection[5].checkbox[0] == 1:
    gapflag=1
    aln_file=yasara.selection[6].filename[0]
    f=open(aln_file,"r")
    count_names={}
    count=0

    for line in f:
      line=line.rstrip()
      count+=1
      field=line.split('\t')

      if(len(field)!=2):
        yasara.plugin.end("The alignment file is not correct. The name and sequence should be seperated with a tab.")

      if field[0] in count_names:
        count_names[field[0]]+=1
      else:
        count_names[field[0]]=0
        count_names[field[0]]+=1

      if "-" in field[1]:
        provided_pdb_seq[field[0]]=field[1].rstrip()
        provided_pdb_seq[field[0]]=provided_pdb_seq[field[0]].replace("-","")
        pdbseq_dashgaps[field[0]]=field[1].rstrip()
      else:
        pdbseq_filledgaps[field[0]]=field[1].rstrip()
    for key in count_names:
      if count_names[key]!=2:
        yasara.plugin.end("The alignment file is not correct. There should be 2 lines present for each molecule with gaps, in the correct format")

  residue=yasara.selection[0].residue[0]
  original=residue.name1
  position_seq=residue.number.inmol
  position_pdb=residue.number.inpdb
  objectnumber=residue.object.number.inyas
  molname=residue.molecule.name
  if molname is ' ':
    yasara.plugin.end("This object contains a molecule with no name (_). Please rename all nameless molecules with Edit > Rename")
  
  name="Obj"+objectnumber+"Mol"+molname
  
  ##if pdbseq does not contain gaps, make dictionary with original pdbseq
  if gapflag==0:
    pdbseq_filledgaps[name]=yasara.SequenceMol(molname+' Obj '+objectnumber)[0]
    pdbseq_dashgaps[name]=yasara.SequenceMol(molname+' Obj '+objectnumber)[0]
    provided_pdb_seq[name]=yasara.SequenceMol(molname+' Obj '+objectnumber)[0]

  if gapflag==1 and name not in provided_pdb_seq:
    yasara.plugin.end("You toggled the checkbox indicating that your sequence contains gaps. However, your alignment file does not contain an identifier matching the molecule you selected")

  if gapflag==1 and yasara.SequenceMol(molname)[0]!=provided_pdb_seq[name]:
    yasara.plugin.end("The PDB sequence provided in the alignment file for"+name+" is not correct. Make sure that these are identical")

  output_fasta = open(os.path.join(cachedir,"WT_seq.fa"),"w")  
  output_fasta.write(">"+name+"\n"+pdbseq_filledgaps[name])
  output_fasta.close()

  seq["WT_seq"]=pdbseq_filledgaps[name]
  # ## Loop over all SEQUENCES IN PDB

  oldtonew={}
  newtoold={}
  oldtonew[name]={}
  newtoold[name]={}

  residues=yasara.ListRes("Obj "+objectnumber+" Mol "+molname,"format=RESNUM")
  count=0
  for x in residues:
    count=count+1
    data=x.split('=')
    oldtonew[name][data[1]]=count
    newtoold[name][count]=data[1]

  ## Loop first over alignment file to see where there are gaps
  res_nr=0
  res_nr_pdb=0
  gap_map[name]={}
  gap_map_inverse[name]={}
  for x in pdbseq_filledgaps[name]:
    if x!=pdbseq_dashgaps[name][res_nr]:
      gap_map[name][res_nr]="N.A."
    else:
      gap_map[name][res_nr]=res_nr_pdb
      gap_map_inverse[name][res_nr_pdb]=res_nr
      pdbnumber=newtoold[name][res_nr_pdb+1]
      res_nr_pdb+=1
    res_nr+=1

  mutations_array=['WT_seq']
  sequence_array=list(pdbseq_filledgaps[name])

  # read in to which AA to mutate and write fasta for each mutant!
  mutations=yasara.selection[1].listentries
  for j in range(mutations):
    shortname=original+position_pdb+aa_dict[yasara.selection[1].listentry[j].upper()]
    mutations_array.append(shortname)
    output_fasta=open(os.path.join(cachedir,shortname+".fa"),"w")
    output_fasta.write(">Obj"+objectnumber+"Mol"+molname+"_"+original+position_pdb+aa_dict[yasara.selection[1].listentry[j].upper()]+"\n")
    #mutate sequence!! 
    mutated_seq=sequence_array
    ## use position that is stored in hash!!
    mutated_seq[int(gap_map_inverse[name][int(position_seq)]-1)]=aa_dict[yasara.selection[1].listentry[j].upper()]
    output_fasta.write(''.join(mutated_seq)+"\n")
    output_fasta.close()
    seq[shortname]=''.join(mutated_seq)


  tango_array=[]

  output=""
  conclusion="Conclusion\n"
  ##loop over all the mutations!
  complete_output=""
  tango_all_global={}

  for mut in mutations_array:
    output_tab= open(os.path.join(cachedir,"all_seq.tab"),"w")
    output_tab.write(mut+"\t"+seq[mut]+"\n")
    output_tab.close()
    ##determine changed residue
    if mut.find('WT')==-1:
      AA=mut[-1:]
      change=aa_dict_2[AA]
    else:
      change="nothing"

    # #which predictor?
    if(yasara.selection[2].checkbox[0] == 1):
      tango = 1
      (tango_global,output)=solubis_mutateres.RunAgadirTango(agadirbin,cachedir,temperature,ph,ionicstrength,TfeConc,stability,concentration,tangowintresh,tangominsize,tangoflanksize,tango_array,objectnumber,mut,position_pdb,change,molname,newtoold,gapflag,gap_map)
      complete_output+=output
      tango_all_global[mut]=tango_global
      if mut.find('WT')==-1:
        dif=float(tango_global)-float(tango_all_global["WT_seq"])
        if dif>50:
          conclusion+="Mutation "+mut+" increases the aggregation tendency with "+ str(dif)+"\n"
        elif dif <-50:
          conclusion+="Mutation "+mut+" decreases the aggregation tendency with "+ str(dif)+"\n"
        else:
          conclusion+="Mutation "+mut+" does not affect the aggregation tendency\n"
      else:
        conclusion+="The WT protein has an aggregation propensity of "+str(tango_all_global["WT_seq"])+"\n"
    else:
      tango = 0  

  if output != "":
    solubisplotoutput.write_outputfile(cachedir,complete_output)
    solubisplotoutput.write_outputfile(cachedir,conclusion)
    
    yasara.write(complete_output)
    yasara.write(conclusion)

  yasara.HideMessage()
  yasara.Console("Open")
  yasara.plugin.end()
# ************************************************************************************
# * save the last calculation in a specified folder (copy entire cache folder there) *
# ************************************************************************************
if (yasara.request=="SaveCalc"):
  # delete some crap
  del_trace=['PdbList*','*_1.pdb','individual_list.txt','Unrecognized_molecules.txt']
  for trace in del_trace:
    trace_path=os.path.join(cachedir,trace)
    for filename in glob.glob(trace_path):
      if os.path.exists(filename):
        os.remove(filename)
  # what to save?
  switchbox = yasara.selection[0].switchbox
  # grab the selected copy folder
  savetarget = yasara.selection[1].filename[0]
  # set the cache dir from the config file
  cachedir = os.path.join(os.getcwd(),yasara.plugin.config["AGADIR_TMP"])
  # check if the path is real
  try:
    # here we assume a folder and not a prefix was selected
    os.listdir(savetarget)
    targetfolder = savetarget
    targetprefix = ""
  except OSError:
    # here we assume a file prefix was given. check if underlying folder is real
    os.listdir(os.path.split(savetarget)[0])
    targetfolder = os.path.split(savetarget)[0]
    targetprefix = os.path.split(savetarget)[1]
  except:
    yasara.plugin.end("No proper folder was selected. You probably specified an unexisting folder.")
  # which files to copy?
  # all files
  if switchbox == 0:
    cachelist = os.listdir(cachedir)
  # only SUMMARY.out file
  else:
    if "SOLUBIS_SUMMARY_TABLE.out" not in os.listdir(cachedir):
      cachelist = ["SOLUBIS_SUMMARY.out"]
    else:
      cachelist = ["SOLUBIS_SUMMARY_TABLE.out","SOLUBIS_SUMMARY.out"]
    # check if file exists, so if last calculation was a modeling task
    if "SOLUBIS_SUMMARY.out" not in os.listdir(cachedir):
      yasara.plugin.end("SOLUBIS_SUMMARY.out file not found.")

  # see if we don't overwrite any files. if so, do not continue
  copylist = os.listdir(targetfolder)
  for filename in cachelist:
    if targetprefix != "" and targetprefix != "*" and targetprefix+"_"+filename in copylist:
      yasara.plugin.end("Identical filenames found in source folder and selected save folder. Please empty the save folder or select a new save folder or choose another filename prefix to avoid overwriting")
    elif (targetprefix == "" or targetprefix == "*") and filename in copylist:
      yasara.plugin.end("Identical filenames found in source folder and selected save folder. Please empty the save folder or select a new save folder or choose another filename prefix to avoid overwriting")    
  # raise error when cache folder is empty
  if cachelist == []:
    yasara.plugin.end("No recent calculation found.")
  # copy the entire cache dir to the copy folder
  for filename in cachelist:
    if targetprefix == "" or targetprefix =="*":
      disk.copy(os.path.join(cachedir,filename),os.path.join(targetfolder,filename))
    else:
      disk.copy(os.path.join(cachedir,filename),os.path.join(targetfolder,targetprefix+"_"+filename))

# ************************************************************************************
# * Lower the aggregation tendency and if necessary, calculate effect on stability *
# ************************************************************************************

if(yasara.request=='LowerMutEnergy'):

  yasara.Console("Hidden")
  yasara.DelWaterAll()
  yasara.NameRes("H1s H2s","HIS")

  ## initialize PDB MAP+other parameters
  oldtonew={}
  newtoold={}
  provided_pdb_seq={}
  pdbseq_dashgaps={}
  pdbseq_filledgaps={}
  gap_map={}
  count_gap_seq=0
  output=""

  ##Write FASTA SEQUENCES TO FILE
  output_fasta = open(os.path.join(cachedir,"all_seq.fa"),"w")
  output_tab = open(os.path.join(cachedir,"all_seq.tab"),"w")

  ## WRITE PARAMETERS TO OPTIONS FILE ##
  temperature_tango = yasara.selection[1].number[0]
  ph_tango = yasara.selection[1].number[1]
  ionicstrength_tango = yasara.selection[1].number[2]
  TfeConc_tango = yasara.selection[1].number[3]
  stability_tango = yasara.selection[1].number[4]
  concentration_tango = yasara.selection[1].number[5]
  tangowintresh = yasara.selection[2].number[0]
  tangominsize = yasara.selection[2].number[1]
  tangoflanksize = yasara.selection[2].number[2]

  ## check if there is a gap in the structure
  gapflag=0
  if yasara.selection[7].checkbox[0] == 1:
    gapflag=1
    aln_file=yasara.selection[8].filename[0]
    f=open(aln_file,"r")
    count_names={}
    count=0
    
    for line in f:
      line=line.rstrip()
      count+=1
      field=line.split('\t')

      if(len(field)!=2):
        yasara.plugin.end("The alignment file is not correct. The name and sequence should be seperated with a tab.")
      
      if field[0] in count_names:
        count_names[field[0]]+=1
      else:
        count_names[field[0]]=0
        count_names[field[0]]+=1


      if "-" in field[1]:
        provided_pdb_seq[field[0]]=field[1].rstrip()
        provided_pdb_seq[field[0]]=provided_pdb_seq[field[0]].replace("-","")
        pdbseq_dashgaps[field[0]]=field[1].rstrip()
      else:
        pdbseq_filledgaps[field[0]]=field[1].rstrip()
    for key in count_names:
      if count_names[key]!=2:
        yasara.plugin.end("The alignment file is not correct. There should be 2 lines present for each molecule with gaps, in the correct format")


  molcount= yasara.selection[0].molecules
  all_sequences ={}
  for i in range(molcount):
    molnumber = yasara.selection[0].molecule[i].number.inyas
    molname = yasara.selection[0].molecule[i].name
    if molname is ' ':
      yasara.plugin.end("This object contains a molecule with no name (_). Please rename all nameless molecules with Edit > Rename")
    molecule = yasara.selection[0].molecule[i]
    objectnumber = molecule.object.number.inyas
    id_mol=molname+' Obj '+objectnumber
    sequence = yasara.SequenceMol(id_mol)
    name="Obj"+objectnumber+"Mol"+molname
    ##if pdbseq does not contain gaps, make dictionary with original pdbseq
    if gapflag==0:
      pdbseq_filledgaps[name]=sequence[0]
      pdbseq_dashgaps[name]=sequence[0]
      provided_pdb_seq[name]=sequence[0]
    if gapflag==1 and name in provided_pdb_seq:
      count_gap_seq+=1
    if gapflag==1 and name not in provided_pdb_seq:
      pdbseq_filledgaps[name]=sequence[0]
      pdbseq_dashgaps[name]=sequence[0]
      provided_pdb_seq[name]=sequence[0]

    if gapflag==1 and sequence[0]!=provided_pdb_seq[name]:
      yasara.plugin.end("The PDB sequence provided in the alignment file for"+name+" is not correct. Make sure that these are identical")

    output_fasta.write(">Obj"+objectnumber+"Mol"+molname+"\n")
    output_tab.write("Obj"+objectnumber+"Mol"+molname+"\t")
    output_fasta.write(pdbseq_filledgaps[name]+"\n")
    output_tab.write(pdbseq_filledgaps[name]+"\n")
    all_sequences["Obj"+objectnumber+"Mol"+molname]=pdbseq_filledgaps[name]

    oldtonew[name]={}
    newtoold[name]={}
    residues=yasara.ListRes("Obj "+objectnumber+" Mol "+molname,"format=RESNUM")
    count=0
    for x in residues:
      count=count+1
      data=x.split('=')
      oldtonew[name][data[1]]=count
      newtoold[name][count]=data[1]

    ## Loop first over alignment file to see where there are gaps
    res_nr=0
    res_nr_pdb=0
    gap_map[name]={}
    for x in pdbseq_filledgaps[name]:
      if x!=pdbseq_dashgaps[name][res_nr]:
        gap_map[name][res_nr]="N.A."
      else:
        gap_map[name][res_nr]=res_nr_pdb
        pdbnumber=newtoold[name][res_nr_pdb+1]
        res_nr_pdb+=1
      res_nr+=1

  output_fasta.close()
  output_tab.close()

 ## FOLDX OPTIONS : Repair PDB or not? Calculate stability or not?

  repair_flag=yasara.selection[3].checkbox[0]
  stability_flag=yasara.selection[3].checkbox[1]

 # grab numerical OPTIONS
  numberofruns = yasara.selection[4].number[0]
  temperature = yasara.selection[4].number[1]
  ph = yasara.selection[4].number[2]
  ionicstrength = str(round(yasara.selection[4].number[3]/100.0,2))
  vdwdesign = yasara.selection[4].number[4]

  if(stability_flag==1):
    solubis_foldx.WriteOptionsFile(cachedir,numberofruns,temperature,ph,ionicstrength,vdwdesign)

  ## TRESHOLD FOR TANGO AND FOLDX  
  TANGO_treshold=yasara.selection[5].number[0]
  FOLDX_treshold=yasara.selection[5].number[1]

  ## HOW MANY MUTATION DO YOU WANT
  numberofmut=yasara.selection[6].number[0]

  ## Run TANGO on WT seq, start from strongest stretch to select lowering mutation, if flag foldx checked => calculate ddG / if flag repair checked => repair object
  output=solubis_main.getzones(agadirbin,cachedir,all_sequences,1,foldxbin,objectnumber,numberofmut,TANGO_treshold,FOLDX_treshold,repair_flag,stability_flag,newtoold,0,100000000,temperature_tango,ph_tango,ionicstrength_tango,TfeConc_tango,stability_tango,concentration_tango,tangowintresh,tangominsize,tangoflanksize,provided_pdb_seq[name],pdbseq_filledgaps[name],gap_map)

  yasara.Console("Open")
  yasara.plugin.end()

if(yasara.request=='MarkRegion'):

  yasara.Console("Hidden")
  yasara.DelWaterAll()
  yasara.NameRes("H1s H2s","HIS")

  ## initialize PDB MAP+other parameters
  oldtonew={}
  newtoold={}
  provided_pdb_seq={}
  pdbseq_dashgaps={}
  pdbseq_filledgaps={}
  gap_map={}
  count_gap_seq=0
  output=""

  ##Write FASTA SEQUENCES TO FILE
  output_fasta = open(os.path.join(cachedir,"all_seq.fa"),"w")
  output_tab=open(os.path.join(cachedir,"all_seq.tab"),"w")

  ## WRITE PARAMETERS TO OPTIONS FILE ##
  temperature_tango = yasara.selection[1].number[0]
  ph_tango = yasara.selection[1].number[1]
  ionicstrength_tango = yasara.selection[1].number[2]
  TfeConc_tango = yasara.selection[1].number[3]
  stability_tango = yasara.selection[1].number[4]
  concentration_tango = yasara.selection[1].number[5]
  tangowintresh = yasara.selection[2].number[0]
  tangominsize = yasara.selection[2].number[1]
  tangoflanksize = yasara.selection[2].number[2]

  ## check if there is a gap in the structure
  gapflag=0
  if yasara.selection[7].checkbox[0] == 1:
    gapflag=1
    aln_file=yasara.selection[8].filename[0]
    f=open(aln_file,"r")
    count_names={}
    count=0
    
    for line in f:
      line=line.rstrip()
      count+=1
      field=line.split('\t')

      if(len(field)!=2):
        yasara.plugin.end("The alignment file is not correct. The name and sequence should be seperated with a tab.")
      
      if field[0] in count_names:
        count_names[field[0]]+=1
      else:
        count_names[field[0]]=0
        count_names[field[0]]+=1

      if "-" in field[1]:
        provided_pdb_seq[field[0]]=field[1].rstrip()
        provided_pdb_seq[field[0]]=provided_pdb_seq[field[0]].replace("-","")
        pdbseq_dashgaps[field[0]]=field[1].rstrip()
      else:
        pdbseq_filledgaps[field[0]]=field[1].rstrip()
    for key in count_names:
      if count_names[key]!=2:
        yasara.plugin.end("The alignment file is not correct. There should be 2 lines present for each molecule with gaps, in the correct format")

  molnames = []
  for i in range(yasara.selection[0].residues):
    if i < yasara.selection[0].residues-1:
      if yasara.selection[0].residue[i].object.number.inyas!=yasara.selection[0].residue[i+1].object.number.inyas:
         yasara.plugin.end("Not all selected residues belong to the same object. Please select residues from the same object")
      if yasara.selection[0].residue[i+1].molecule.name!=yasara.selection[0].residue[i].molecule.name:
         yasara.plugin.end("Not all selected residues belong to the same molecule. Please select residues from the same molecule")
    objectnumber=yasara.selection[0].residue[i].object.number.inyas
    molname = yasara.selection[0].residue[i].molecule.name
    if molname is ' ':
      yasara.plugin.end("This object contains a molecule with no name (_). Please rename all nameless molecules with Edit > Rename")
    
  low_bound=yasara.selection[0].residue[0].number.inmol
  up_bound=yasara.selection[0].residue[-1].number.inmol

  molcount= yasara.selection[0].molecules
  all_sequences ={}

  sequence = yasara.SequenceMol(molname+' Obj '+objectnumber)
  name="Obj"+objectnumber+"Mol"+molname

  ##if pdbseq does not contain gaps, make dictionary with original pdbseq
  if gapflag==0:
    pdbseq_filledgaps[name]=sequence[0]
    pdbseq_dashgaps[name]=sequence[0]
    provided_pdb_seq[name]=sequence[0]
  if gapflag==1 and name in provided_pdb_seq:
    count_gap_seq+=1
  if gapflag==1 and name not in provided_pdb_seq:
    pdbseq_filledgaps[name]=sequence[0]
    pdbseq_dashgaps[name]=sequence[0]
    provided_pdb_seq[name]=sequence[0]

  if gapflag==1 and sequence[0]!=provided_pdb_seq[name]:
    yasara.plugin.end("The PDB sequence provided in the alignment file for"+name+" is not correct. Make sure that these are identical")

  output_fasta.write(">"+name+"\n")
  output_fasta.write(pdbseq_filledgaps[name]+"\n")
  output_tab.write(name+"\t"+pdbseq_filledgaps[name]+"\n")
  all_sequences["Obj"+objectnumber+"Mol"+molname]=pdbseq_filledgaps[name]

  oldtonew[name]={}
  newtoold[name]={}
  residues=yasara.ListRes("Obj "+objectnumber+" Mol "+molname,"format=RESNUM")
  count=0
  for x in residues:
    count=count+1
    data=x.split('=')
    oldtonew[name][data[1]]=count
    newtoold[name][count]=data[1]
    ## Loop first over alignment file to see where there are gaps
    res_nr=0
    res_nr_pdb=0
    gap_map[name]={}
  for x in pdbseq_filledgaps[name]:
    if x!=pdbseq_dashgaps[name][res_nr]:
      gap_map[name][res_nr]="N.A."
    else:
      gap_map[name][res_nr]=res_nr_pdb
      pdbnumber=newtoold[name][res_nr_pdb+1]
      res_nr_pdb+=1
    res_nr+=1

  output_fasta.close()
  output_tab.close()

 ## FOLDX OPTIONS : Repair PDB or not? Calculate stability or not?
  repair_flag=yasara.selection[3].checkbox[0]
  stability_flag=yasara.selection[3].checkbox[1]

 # grab numerical OPTIONS
  numberofruns = yasara.selection[4].number[0]
  temperature = yasara.selection[4].number[1]
  ph = yasara.selection[4].number[2]
  ionicstrength = str(round(yasara.selection[4].number[3]/100.0,2))
  vdwdesign = yasara.selection[4].number[4]

  if(stability_flag==1):
    solubis_foldx.WriteOptionsFile(cachedir,numberofruns,temperature,ph,ionicstrength,vdwdesign)

  ## TRESHOLD FOR TANGO AND FOLDX  
  TANGO_treshold=yasara.selection[5].number[0]
  FOLDX_treshold=yasara.selection[5].number[1]

  ## HOW MANY MUTATION DO YOU WANT
  numberofmut=yasara.selection[6].number[0]

  ## Run TANGO on WT seq, start from strongest stretch to select lowering mutation, if flag foldx checked => calculate ddG / if flag repair checked => repair object
  output=solubis_main.getzones(agadirbin,cachedir,all_sequences,1,foldxbin,objectnumber,numberofmut,TANGO_treshold,FOLDX_treshold,repair_flag,stability_flag,newtoold,low_bound,up_bound,temperature_tango,ph_tango,ionicstrength_tango,TfeConc_tango,stability_tango,concentration_tango,tangowintresh,tangominsize,tangoflanksize,provided_pdb_seq[name],pdbseq_filledgaps[name],gap_map)
  

  yasara.Console("Open")
  yasara.plugin.end()
# #****************
# # stop the plugin
# # ****************
yasara.plugin.end()
