#!/usr/bin/python

import yasara,os,re,subprocess
import solubisplotoutput
import solubis_foldx
import solubis_run
from python2to3 import *

# amino acid residue list
aas = ['A','C','D','E','F','G','H','I','K','L','M','N','P','Q','R','S','T','V','W','Y']
# residue conversion dictionnary
aa_dict = {'ALA':'A','CYS':'C','ASP':'D','GLU':'E','PHE':'F','GLY':'G','HIS':'H','ILE':'I','LYS':'K','LEU':'L','MET':'M','ASN':'N','PRO':'P','GLN':'Q','ARG':'R','SER':'S','THR':'T','VAL':'V','TRP':'W','TYR':'Y','H1S':'H','H2S':'H'}
inv_aa_dict = dict((v,k) for k, v in aa_dict.items())

def getzones(agadirbin,cachedir,sequences,flag,foldxbin,objnumber,numberofmut,TANGO_threshold,FOLDX_threshold,repair_flag,stability_flag,pdbmap,lower_bound,upper_bound,temperature,ph,ionicstrength,TfeConc,stability,concentration,tangowintresh,tangominsize,tangoflanksize,pdbseq,fullseq,gapmap):
  WriteTango(cachedir,agadirbin,temperature,ph,ionicstrength,TfeConc,stability,concentration,"all_seq.tab")  
  os.chdir(cachedir)
  os.system("chmod 755 tango.sh")
  if (yasara.opsys=='Windows'):
    shell_file = open("./tango.sh",'r').readlines()
    for shell_line in shell_file:
      subprocess.call(shell_line,shell=True)
  if (yasara.opsys!='Windows'):
    os.system("./tango.sh")
  create_windowsfile(cachedir,tangowintresh,tangominsize,tangoflanksize)

  output_2=""
  output_neg=""
  output_destab=""
  count_neg=0
  count_destab=0
  mutated_sequence={}
  mutated_sequence_pdb={}
  global_output=""
  table_output=solubisplotoutput.plot_header_solubis()
  gap_flag_global=0
  zones_global=0

  ## to keep track of how many mutations fulfill criteria of stab and lowering aggregation
  count=0
  scores={}
  identifier=""


  if not os.path.exists("tangowindow.out"):
    output_2+="No aggregating stretches present in this molecule, impossible to lower aggregation tendency\n"
    yasara.write(output_2)
    return(output_2)
  else:    
    yasara.Console("Hidden")
    tangowindow = open("tangowindow.out","r")
    if len(open("tangowindow.out").readlines())>=1:
      for line in tangowindow:
        gap_flag=0
        if line[0:8].find("Obj") != -1 :
          name = line.split("\t")[0]
          if re.match(r"Obj(\d+)Mol(\w+)",name):
            m=re.match(r"Obj(\d+)Mol(\w+)",name)
            pdb_object=m.group(1)
            pdb_molecule=m.group(2)
            position = line.split("\t")[1]
            length = line.split("\t")[6]
            start=int(position)
            end=int(position)+int(length)-1
            for x in range(end-start+1):
              number=start+x-1
              if gapmap[name][int(number)]=="N.A.":
                gap_flag=1
                
            if(gap_flag!=1):
              identifier=name+"_"+str(start)+"_"+str(end)
              scores[identifier]=line.split("\t")[5]
            else:
              gap_flag_global+=1

    else:
      output_2+="No aggregating stretches present in this molecule, impossible to lower aggregation tendency\n"
      yasara.write(output_2)
      return(output_2)
    yasara.HideMessage()

    WT_seq=sequences[name]
    WT_name=name
    ## Loop over sorted aggregation stretches, start with strongest one!
    ##create flag to see if there are aggregating stretches in selection ##
    flag_zones=0
    for (k,v) in sorted(scores.items(),key= lambda x: x[1],reverse=True):
      ## write WT sequence already to mutations file
      output_fasta="mutations.fa"
      output_tab="mutations.tab"
      output=open(os.path.join(cachedir,output_fasta),"w")
      output_tab=open(os.path.join(cachedir,output_tab),"w")
      output.write(">"+WT_name+"\n")
      output_tab.write(WT_name+"\t")
      for aa in sequences[WT_name]:
        if aa in aas:
          output.write(aa)
          output_tab.write(aa)
      output.write("\n")
      output_tab.write("\n")
      output.close()
      output_tab.close()
    
      yasara.ShowMessage("Controlling if there are mutations that lower the aggregation tendency.")
      start=k.split("_")[1]
      end=k.split("_")[2]

      if int(start)>int(lower_bound) and int(end)<int(upper_bound):
        flag_zones=flag_zones+1
      if int(start)<int(lower_bound) and int(end)<=int(upper_bound) and int(end)>=int(lower_bound):
        start=lower_bound
        flag_zones=flag_zones+1
      if int(start)>=int(lower_bound) and int(start)<=int(upper_bound) and int(end)>int(upper_bound):
        end=upper_bound
        flag_zones=flag_zones+1
      if int(lower_bound)>=int(start) and int(upper_bound)<=int(end):
        start=lower_bound
        end=upper_bound
        flag_zones=flag_zones+1
      if int(start)>int(lower_bound) and int(start)>int(upper_bound):
        continue
      if int(end)<int(upper_bound) and int(end)<int(lower_bound):
        continue

      mutated_sequence,mutated_sequence_pdb=make_mutant_seqfile(cachedir,sequences[WT_name],pdbseq,start,end,gapmap,WT_name,mutated_sequence,mutated_sequence_pdb)
      WriteTango(cachedir,agadirbin,temperature,ph,ionicstrength,TfeConc,stability,concentration,"mutations.tab")  
      os.chdir(cachedir)
      os.system("chmod 755 tango.sh")
      if (yasara.opsys=='Windows'):
        shell_file = open("./tango.sh",'r').readlines()
        for shell_line in shell_file:
          subprocess.call(shell_line,shell=True)
      if (yasara.opsys!='Windows'):
        os.system("./tango.sh")
      calculate_globalscore(cachedir,"mutations.tab")
      WT_tango={}
      lowering_flag=0
      lowering_mut=[]
      lowering_mut_seq={}
      lowering_mut_score={}
      lowering_mut_ddg={}
      lowering_mut_pdbpos={}
      ## Loop over all the mutations in a certain stretch!
      TangoGlobal=open(os.path.join(cachedir,"global_tango_scores.txt"),"r")
      for line in TangoGlobal:
        name=line.split("\t")[0]
        if re.match(r"Obj(\d+)Mol(\w+)_(\w)(\d+)(\w)",name):
          m=re.match(r"Obj(\d+)Mol(\w+)_(\w)(\d+)(\w)",name)
          pdb_object=m.group(1)
          pdb_molecule=m.group(2)
          original=m.group(3)
          position=m.group(4)
          mutation=m.group(5)
         
          difference=round((float(WT_tango[WT_name])-float(line.split("\t")[1])),2)

          if difference > TANGO_threshold:
            lowering_flag=1
            lowering_mut_seq[original+position+mutation]=mutated_sequence[name]
            lowering_mut_score[original+position+mutation]=difference
            lowering_mut.append(original+position+mutation)
            lowering_mut_pdbpos[original+position+mutation]=pdbmap[WT_name][gapmap[WT_name][int(position)-1]+1]
          else:
            count_neg=count_neg+1
            if difference < 0:
              output_neg+="Mutation "+original+pdbmap[WT_name][gapmap[WT_name][int(position)-1]+1]+mutation+" increases the aggregation tendency with "+str(-difference)+"\n"
            else: 
              output_neg+="Mutation "+original+pdbmap[WT_name][gapmap[WT_name][int(position)-1]+1]+mutation+" lowers the aggregation tendency with "+str(difference)+"\n"
            table_output+=solubisplotoutput.plot_solubis_entries(WT_name,original+position+mutation,original+pdbmap[WT_name][gapmap[WT_name][int(position)-1]+1]+mutation,-difference,"N.A.","NO")

        elif re.match(r"Obj(\d+)Mol(\w+)",name):
          m=re.match(r"Obj(\d+)Mol(\w+)",name)
          pdb_object=m.group(1)
          pdb_molecule=m.group(2)
          WT_tango["Obj"+pdb_object+"Mol"+pdb_molecule]=line.split("\t")[1]
      yasara.HideMessage()
      ## Check for each stretch whether you find lowering mutation!
      if lowering_flag==1:
        ## check if people want to calculate stability difference
        if stability_flag==1:
          ## check if you need to repair the object first!
          if repair_flag==1:
            repair_flag=solubis_foldx.repair(cachedir,foldxbin,objnumber)
          else:
            pdbfilename="RepairPDB_Object"+objnumber+".pdb"
            yasara.SavePDB(objnumber,os.path.join(cachedir,pdbfilename))

          ## sort them based on score: higher score means more lowering of aggregation tendency
          for (k,v) in sorted(lowering_mut_score.items(),key= lambda x: x[1],reverse=True):
            mut_seq=lowering_mut_seq[k]
            tmp=list(k)
            pdb_pos=pdbmap[WT_name][gapmap[WT_name][int(''.join(tmp[1:-1]))-1]+1]
            solubis_foldx.writeindividuallist(cachedir,tmp[0],pdb_pos,tmp[-1],pdb_molecule)
            mut_pdbpos=tmp[0]+pdb_pos+tmp[-1]
            ddg=solubis_foldx.runbuildmodel(cachedir,foldxbin,objnumber,mut_pdbpos)
            ## ADD DDG in hash if it fulfills criteria!
            if (ddg < FOLDX_threshold):
              lowering_mut_ddg[k]=round(ddg,2)
            else:
              count_destab=count_destab+1
              output_destab+="Mutation "+k[0]+lowering_mut_pdbpos[k]+k[-1]+" lowers the aggregation tendency with "+str(v)+" but has a difference in stability of "+str(round(ddg,2))+"\n"
              table_output+=solubisplotoutput.plot_solubis_entries(WT_name,k[0]+k[1:-1]+k[-1],k[0]+lowering_mut_pdbpos[k]+k[-1],-v,round(ddg,2),"NO")

      if stability_flag==1:
        ## loop over ddG in ordered way

        for (mut,ddg) in sorted(lowering_mut_ddg.items(),key= lambda x: x[1]):
          if (ddg<FOLDX_threshold) :
            count=count+1
            
            pdbfilename=mut[0]+lowering_mut_pdbpos[mut]+mut[-1]

            output_2+="Mutation "+mut[0]+lowering_mut_pdbpos[mut]+mut[-1]+" lowers aggregation tendency with "+str(lowering_mut_score[mut])+" and has a difference in stability of "+str(round(ddg,2))+"\n"
            table_output+=solubisplotoutput.plot_solubis_entries(WT_name,mut[0]+mut[1:-1]+mut[-1],mut[0]+lowering_mut_pdbpos[mut]+mut[-1],round(-lowering_mut_score[mut],2),round(ddg,2),"YES")
            if count>=numberofmut:
               yasara.HideMessage()
               if count_neg>0:
                 yasara.write("These mutations do not lower the aggregation tendency enough (threshold ="+str(TANGO_threshold)+"):\n")
                 yasara.write(output_neg)
                 global_output+="These mutations do not lower the aggregation tendency enough (threshold ="+str(TANGO_threshold)+"):\n"
                 global_output+=output_neg
               if count_destab>0:
                 yasara.write("\nThese mutations lower the aggregation tendency but destabilize too much (threshold: ddG<"+str(FOLDX_threshold)+"):\n")
                 yasara.write(output_destab)
                 global_output+="\nThese mutations lower the aggregation tendency but destabilize too much (threshold: ddG<"+str(FOLDX_threshold)+"):\n"
                 global_output+=output_destab
               yasara.write("\nThese mutations fulfill the criteria:\n")
               yasara.write(output_2)
               global_output+="\nThese mutations fulfill the criteria:\n"
               global_output+=output_2
               yasara.Console("Open")
               solubisplotoutput.write_outputfile(cachedir,global_output)
               solubisplotoutput.write_outputfile_table(cachedir,table_output)
               yasara.plugin.end()

      else:
        for (mut,dif_tango) in sorted(lowering_mut_score.items(),key= lambda x: x[1],reverse=True):
          count=count+1
          output_2+="Mutation "+mut[0]+lowering_mut_pdbpos[mut]+mut[-1]+" lowers aggregation tendency with "+str(lowering_mut_score[mut])+"\n"
          table_output+=solubisplotoutput.plot_solubis_entries(WT_name,mut[0]+lowering_mut_pdbpos[mut]+mut[-1],-lowering_mut_score[mut],"N.A","YES")
          if count>=numberofmut:
               yasara.HideMessage()
               if count_neg>0:
                 yasara.write("These mutations do not lower the aggregation tendency enough (threshold ="+str(TANGO_threshold)+"):\n")
                 yasara.write(output_neg)
                 global_output+="These mutations do not lower the aggregation tendency enough (threshold ="+str(TANGO_threshold)+"):\n"
                 global_output+=output_neg

               yasara.write("These mutations fulfill the criteria:\n")
               yasara.write(output_2)

               global_output+="These mutations fulfill the criteria:\n"
               global_output+=output_2
               yasara.Console("Open")
               solubisplotoutput.write_outputfile(cachedir,global_output)
               solubisplotoutput.write_outputfile_table(cachedir,table_output)
               yasara.plugin.end()

    if count>0:
        yasara.HideMessage()
        if count_neg>0:
          yasara.write("These mutations do not lower the aggregation tendency enough (threshold ="+str(TANGO_threshold)+"):\n")
          yasara.write(output_neg)
          global_output+="These mutations do not lower the aggregation tendency enough (threshold ="+str(TANGO_threshold)+"):\n"
          global_output+=output_neg+"\n"
        if count_destab>0:
          yasara.write("These mutations lower the aggregation tendency but destabilize too much (threshold: ddG<"+str(FOLDX_threshold)+"):\n")
          yasara.write(output_destab)
          global_output+="These mutations lower the aggregation tendency but destabilize too much (threshold: ddG<"+str(FOLDX_threshold)+"):\n"
          global_output+=output_destab+"\n"
        yasara.write("These mutations fulfill the criteria:\n")
        yasara.write(output_2)
        global_output+="These mutations fulfill the criteria:\n"
        global_output+=output_2
        yasara.Console("Open")
        solubisplotoutput.write_outputfile(cachedir,global_output)
        solubisplotoutput.write_outputfile_table(cachedir,table_output)
        yasara.plugin.end()


    if flag_zones==0:
      if int(lower_bound)==0 and int(upper_bound)==100000000:
        yasara.ShowMessage("No aggregating stretches present in this molecule. Impossible to lower the aggrgation tendency ")
      else:
        yasara.ShowMessage("No aggregating stretches present in marked region. Impossible to lower the aggregation tendency ")

    if count==0:
      if stability_flag==1: 
        if count_neg>0:
          yasara.write("These mutations do not lower the aggregation tendency enough (threshold ="+str(TANGO_threshold)+"):\n")
          yasara.write(output_neg)
          global_output+="These mutations do not lower the aggregation tendency enough (threshold ="+str(TANGO_threshold)+"):\n"
          global_output+=output_neg+"\n"
        if count_destab>0:
          yasara.write("These mutations lower the aggregation tendency but destabilize too much (threshold: ddG<"+str(FOLDX_threshold)+"):\n")
          yasara.write(output_destab)
          global_output+="These mutations lower the aggregation tendency but destabilize too much (threshold: ddG<"+str(FOLDX_threshold)+"):\n"
          global_output+=output_destab+"\n"       
        yasara.ShowMessage("No mutations that lower the aggregation tendency and stabilize the protein. You can try to lower the thresholds.")
      else:
          yasara.write("These mutations do not lower the aggregation tendency enough (threshold ="+str(TANGO_threshold)+"):\n")
          yasara.write(output_neg)
          global_output+="These mutations do not lower the aggregation tendency enough (threshold ="+str(TANGO_threshold)+"):\n"
          global_output+=output_neg+"\n"
          yasara.ShowMessage("No mutations that lower the aggregation tendency. You can try to lower the threshold.")
          
    yasara.HideMessage()
    yasara.write(output_2)

    yasara.Console("Open")
    solubisplotoutput.write_outputfile(cachedir,global_output)
    solubisplotoutput.write_outputfile_table(cachedir,table_output)
    yasara.plugin.end()
  
def make_mutant_seqfile(cachedir,sequence,pdbseq,start,end,gapmap,name,sequences,sequences_pdb):
  GK=["R","K","D","E","P"]
  output_fasta="mutations.fa"
  output=open(os.path.join(cachedir,output_fasta),"a")
  output_tab=open(os.path.join(cachedir,"mutations.tab"),"a")
  ##loop over sequence from start to end!
  start=int(start)
  end=int(end)
  for x in range(end-start+1):
    position=start+x-1
    for aa in GK:

      mutated_seq=list(sequence)
      mutated_seq[position]=aa
      mutated_seq_pdb=list(pdbseq)
      mutated_seq_pdb[gapmap[name][position]]=aa
      output.write(">"+name+"_"+sequence[position]+str(position+1)+aa+"\n")
      output_tab.write(name+"_"+sequence[position]+str(position+1)+aa+"\t")
      for aa_seq in mutated_seq:
        if aa_seq in aas:
          output.write(aa_seq)
          output_tab.write(aa_seq)
      output.write("\n")
      output_tab.write("\n")
## DON'T HAVE TO JOIN THE ARRAY TO STRING??
      sequences[name+"_"+sequence[position]+str(position+1)+aa]=''.join(mutated_seq)
      sequences_pdb[name+"_"+sequence[position]+str(position+1)+aa]=''.join(mutated_seq_pdb)
  output.close()
  output_tab.close()
  return(sequences,sequences_pdb)

def WriteTango(cachedir,agadirbin,temperature,ph,ionicstrength,Tfecon,stability,concentration,seq):
  file=open(os.path.join(cachedir,seq),"r")
  tango_command=open(os.path.join(cachedir,"tango.sh"),"w")
  for line in file:
    line.rstrip('\n')
    name=line.split("\t")[0]
    seq=line.split("\t")[1].rstrip('\n')
    if (yasara.opsys=='Windows'):
      tango_command.write(agadirbin+" "+name+" nt='N' ct='N' ph="+str(ph)+" te="+str(temperature)+" io="+str(ionicstrength)+" tf="+str(Tfecon)+" stab="+str(stability)+" seq="+seq+"\n")
    if (yasara.opsys!='Windows'):
      tango_command.write(agadirbin+" "+name+" nt='N' ct='N' ph="+str(ph)+" te="+str(temperature)+" io="+str(ionicstrength)+" tf="+str(Tfecon)+" stab="+str(stability)+" seq="+seq+" > "+os.path.join(cachedir,name)+".txt\n")
  tango_command.close()

def create_windowsfile(cachedir,tangowintresh,tangominsize,tangoflanksize):
  seq=open(os.path.join(cachedir,"all_seq.tab"),"r")
  tango_window=open(os.path.join(cachedir,"tangowindow.out"),"w")
  for line in seq:
    line.rstrip()
    name=line.split("\t")[0]
    seq=line.split("\t")[1]
    flag=0
    count=0
    tango_output=open(os.path.join(cachedir,name+'.txt'),"r")
    for line in tango_output:
      count=count+1
      if count>1:
        tmp=line.split("\t")
        tangoscore=float(tmp[5].strip(' '))
        ##begin of zone
        if(flag==0 and tangoscore>=tangowintresh):
          flag=1
          windowbegin=int(tmp[0].strip(' '))
          tangoscore_tmp=tangoscore
        #continue zone
        elif(flag==1 and tangoscore>=tangowintresh):
          tangoscore_tmp+=tangoscore
        #end of zone
        elif(flag==1 and tangoscore<tangowintresh):
          windowend=int(tmp[0].strip(' '))-1
          length=windowend-windowbegin+1
          if length>=tangominsize:
            #make sequence
            gkbegin=windowbegin-tangoflanksize
            if(gkbegin<0):gkbegin=0
            gkend=windowend+tangoflanksize
            if(gkend>len(seq)):gkend=len(seq) ## ??? how to check length of sequence molecule!!!!???? ?? how to retrieve sequence???
            length=windowend-windowbegin+1
            norm_tango=tangoscore_tmp/length
            tango_window.write(name+'\t'+str(windowbegin)+'\t'+seq[gkbegin-1:windowbegin-1]+'\t'+seq[windowbegin-1:windowend]+'\t'+seq[windowend:gkend].rstrip()+'\t'+str(round(tangoscore_tmp,2))+'\t'+str(length)+'\n')## write out in same manner as tangowindow!!!!!
          flag=0
  tango_window.close()


def calculate_globalscore(cachedir,input):
  seq=open(os.path.join(cachedir,"mutations.tab"),"r")
  TangoGlobal=open(os.path.join(cachedir,"global_tango_scores.txt"),"w")
  for line in seq:
    line.rstrip()
    name=line.split("\t")[0]
    tango_global=0
    tango_output=open(os.path.join(cachedir,name+'.txt'),"r")
    count=0
    for line in tango_output:
      count=count+1
      if count>1:
        tmp=line.split("\t")
        tangoscore=float(tmp[5].strip(' '))
        tango_global+=tangoscore
    TangoGlobal.write(name+'\t'+str(tango_global)+'\n')
