#!/usr/bin/python


import yasara,os,re,subprocess
import solubisplotoutput
from python2to3 import *

# Write Agadir OPTIONS file
# =========================

def RunAgadirTango(agadirbin,cachedir,temperature,ph,ionicstrength,Tfecon,stability,concentration,tangowintresh,tangominsize,tangoflanksize,tango_array,objectnumber,input,pos_mut,change,pdbmol,pdbmap,gapflag,gapmap):
  WriteTango(cachedir,agadirbin,temperature,ph,ionicstrength,Tfecon,stability,concentration)  
  os.chdir(cachedir)
  os.system("chmod 755 tango.sh")
  if (yasara.opsys=='Windows'):
    shell_file = open("./tango.sh",'r').readlines()
    for shell_line in shell_file:
      subprocess.call(shell_line,shell=True)
  if (yasara.opsys!='Windows'):
      os.system("./tango.sh")
  tango_global=calculate_globalscore(cachedir,input)
  create_windowsfile(cachedir,tangowintresh,tangominsize,tangoflanksize)

  ## Define values
  gap_flag_global=0
  zones_global=0 
  output=""
  
  if input.find('WT')!=-1:
    name="Wild Type"
    input="WT"
  else:
    name="Mutant"+input
  output+="Tango-output for: Object "+objectnumber+" Mol "+pdbmol+" "+input+"\n"

  pdbfilename=input+"_Tango"
  ## no duplicate obj in yasar view; use saveYob/LoadYob
  #newobjlist=yasara.DuplicateObj(objectnumber)
  yasara.SavePDB(objectnumber,os.path.join(cachedir,'Object'+str(objectnumber)+'.pdb'))
  newobjlist=yasara.LoadPDB(os.path.join(cachedir,'Object'+str(objectnumber)+'.pdb'))
  yasara.NameObj(newobjlist[0],pdbfilename)
  yasara.ColorObj(newobjlist[0],"gray")
  yasara.Style("Ribbon")
  yasara.SupAtom("Backbone Obj "+str(newobjlist[0]),"Backbone Obj "+str(objectnumber),"Yes")
  yasara.SwitchObj(newobjlist[0],"off",1)
  if not os.path.exists("tangowindow.txt"):
    output+="No tango stretches in "+name+"\n"   
  else:
    yasara.Console("Hidden")
    tangowindow = open("tangowindow.txt","r")
    if len(open("tangowindow.txt").readlines())>=1:
      output_header=solubisplotoutput.plotoutput_header()
      output+=output_header
      count = 0
      for line in tangowindow:
        ## Define values
        gap_flag_global=0
        zones_global=0
        flag_present=0
        gap=0
        name = line.split("\t")[0]
        position = line.split("\t")[1]
        length = line.split("\t")[6]
        
        name="Obj"+objectnumber+"Mol"+pdbmol
        
        start=int(position)
        end=int(position)+int(length)-1
        ## check whether stretch is in gap in structure
        for x in range(end-start+1):
          number=start+x-1
          if gapmap[name][number]!="N.A.":
            flag_present+=1
            yasara.ColorRes("Obj "+str(newobjlist[0])+" Mol "+pdbmol+" Res "+str(pdbmap[name][gapmap[name][number]+1]),"Red")
          else:
            gap=1

        if gap==1:
          if flag_present>0:
            output+=solubisplotoutput.plotoutput_entries(name,"tango",start,pdbmap[name][gapmap[name][start-1]+1],line.split("\t")[2],line.split("\t")[3],line.split("\t")[4],line.split("\t")[5],"YES but not completely")
          else:
            output+=solubisplotoutput.plotoutput_entries(name,"tango",start,"N.A.",line.split("\t")[2],line.split("\t")[3],line.split("\t")[4],line.split("\t")[5],"NO")
          
        else:
          output+=solubisplotoutput.plotoutput_entries(name,"tango",start,pdbmap[name][gapmap[name][start-1]+1],line.split("\t")[2],line.split("\t")[3],line.split("\t")[4],line.split("\t")[5],"YES")

     
    else:
      output+="No tango stretches in "+input+" \n"
##COLOR AND SHOW MUTATED RESIDUE
  if input.find('WT')==-1:
    yasara.SwapRes("Obj "+str(newobjlist[0])+" Mol "+pdbmol+" Res "+pos_mut,change)
    yasara.ColorRes("Obj "+str(newobjlist[0])+" Mol "+pdbmol+" Res "+pos_mut,"magenta")
    yasara.ShowAtom("Obj "+str(newobjlist[0])+" Mol "+pdbmol+" Res "+pos_mut)

  return(tango_global,output)

def WriteTango(cachedir,agadirbin,temperature,ph,ionicstrength,Tfecon,stability,concentration):
  file=open(os.path.join(cachedir,"all_seq.tab"),"r")
  tango_command=open(os.path.join(cachedir,"tango.sh"),"w")
  for line in file:
    line.rstrip('\n')
    name=line.split("\t")[0]
    seq=line.split("\t")[1].rstrip('\n')
    if (yasara.opsys=='Windows'):
      tango_command.write(agadirbin+" "+name+" nt='N' ct='N' ph="+str(ph)+" te="+str(temperature)+" io="+str(ionicstrength)+" tf="+str(Tfecon)+" stab="+str(stability)+" seq="+seq+"\n")
    if (yasara.opsys!='Windows'):
      tango_command.write(agadirbin+" "+name+" nt='N' ct='N' ph="+str(ph)+" te="+str(temperature)+" io="+str(ionicstrength)+" tf="+str(Tfecon)+" stab="+str(stability)+" seq="+seq+" > "+os.path.join(cachedir,name)+".txt\n")
  tango_command.close()

def create_windowsfile(cachedir,tangowintresh,tangominsize,tangoflanksize):
  seq=open(os.path.join(cachedir,"all_seq.tab"),"r")
  tango_window=open(os.path.join(cachedir,"tangowindow.txt"),"w")
  for line in seq:
    line.rstrip()
    name=line.split("\t")[0]
    seq=line.split("\t")[1]
    flag=0
    count=0
    tango_output=open(os.path.join(cachedir,name+'.txt'),"r")
    for line in tango_output:
      count=count+1
      if count>1:
        tmp=line.split("\t")
        tangoscore=float(tmp[5].strip(' '))
        ##begin of zone
        if(flag==0 and tangoscore>=tangowintresh):
          flag=1
          windowbegin=int(tmp[0].strip(' '))
          tangoscore_tmp=tangoscore
        #continue zone
        elif(flag==1 and tangoscore>=tangowintresh):
          tangoscore_tmp+=tangoscore
        #end of zone
        elif(flag==1 and tangoscore<tangowintresh):
          windowend=int(tmp[0].strip(' '))-1
          length=windowend-windowbegin+1
          if length>=tangominsize:
            #make sequence
            gkbegin=windowbegin-tangoflanksize
            if(gkbegin<0):gkbegin=0
            gkend=windowend+tangoflanksize
            if(gkend>len(seq)):gkend=len(seq) ## ??? how to check length of sequence molecule!!!!???? ?? how to retrieve sequence???
            norm_tango=tangoscore_tmp/length
            tango_window.write(name+'\t'+str(windowbegin)+'\t'+seq[gkbegin-1:windowbegin-1]+'\t'+seq[windowbegin-1:windowend]+'\t'+seq[windowend:gkend].rstrip()+'\t'+str(round(tangoscore_tmp,2))+'\t'+str(length)+'\n')## write out in same manner as tangowindow!!!!!
          flag=0
  tango_window.close()

def calculate_globalscore(cachedir,mut):
  tango_global=0
  tango_output=open(os.path.join(cachedir,mut+'.txt'),"r")
  count=0
  for line in tango_output:
    count=count+1
    if count>1:
      tmp=line.split("\t")
      tangoscore=float(tmp[5].strip(' '))
      tango_global+=tangoscore
  return(tango_global)
