#!/usr/bin/python

import yasara,os,re
import solubisplotoutput,subprocess
from python2to3 import *

def RunAgadirTango(agadirbin,cachedir,temperature,ph,ionicstrength,Tfecon,stability,concentration,tangowintresh,tangominsize,tangoflanksize,tango_array,output,visual,coloring,objectnumber,flagmolobj,pdbmap,gapflag,gapmap):
  WriteTango(cachedir,agadirbin,temperature,ph,ionicstrength,Tfecon,stability,concentration)  
  os.chdir(cachedir)
  os.system("chmod 755 tango.sh")
  if (yasara.opsys=='Windows'):
    shell_file = open("./tango.sh",'r').readlines()
    for shell_line in shell_file:
      subprocess.call(shell_line,shell=True)
  if (yasara.opsys!='Windows'):
      os.system("./tango.sh")
  create_windowsfile(cachedir,tangowintresh,tangominsize,tangoflanksize)
  output+="Tango-output:\n"
  if visual==0 and flagmolobj==0:
    yasara.ColorObj(objectnumber,"gray")
    yasara.Style("Ribbon")
  elif visual==1:
    pdbfilename="Obj"+str(objectnumber)+"_tango"
    yasara.SavePDB(objectnumber,os.path.join(cachedir,'Object'+str(objectnumber)+'.pdb'))
    newobjlist=yasara.LoadPDB(os.path.join(cachedir,'Object'+str(objectnumber)+'.pdb'))
    yasara.NameObj(newobjlist[0],pdbfilename)
    yasara.ColorObj(newobjlist[0],"gray")
    yasara.Style("Ribbon")
    yasara.SupAtom("Backbone Obj "+str(newobjlist[0]),"Backbone Obj "+str(objectnumber),"Yes")
    yasara.SwitchObj(newobjlist[0],"off",1)
  if not os.path.exists("tangowindow.out"):
    output+="No tango stretches in this molecule\n"
    return(tango_array,output)
  else:
    yasara.Console("Hidden")
    tangowindow = open("tangowindow.out","r")
    if len(open("tangowindow.out").readlines())>=1:
      output_header=solubisplotoutput.plotoutput_header()
      output+=output_header
      count = 0
      for line in tangowindow:
        gap=0
        flag_present=0
        if line[0:8].find("Obj") != -1 :

          count+=1
          name = line.split("\t")[0]
          if re.match(r"Obj(\d+)Mol(\w+)",name):
            m=re.match(r"Obj(\d+)Mol(\w+)",name)
            pdb_object=m.group(1)
            pdb_molecule=m.group(2)
            position = line.split("\t")[1]
            score = float(line.split("\t")[5].strip(' '))
            length = line.split("\t")[6]
            name="Obj"+pdb_object+"Mol"+pdb_molecule

            start=int(position)
            end=int(position)+int(length)-1
            ## check whether stretch is in gap in structure
            for x in range(end-start+1):
              
              number=start+x-1

              if gapmap[name][number]!="N.A.":
                flag_present+=1       
                if visual == 0:
                  res="Obj "+pdb_object+" Mol "+pdb_molecule+" Res "+str(pdbmap[name][gapmap[name][number]+1])
                elif visual ==1:
                  res="Obj "+str(newobjlist[0])+" Mol "+pdb_molecule+" Res "+str(pdbmap[name][gapmap[name][number]+1])
                if coloring == 0:
                  yasara.ColorRes(res,"Red")
                elif coloring == 1:
                  score_norm = float(score/int(length))
                  colorfactor = float(score_norm/100*60)
                  color = int(180-colorfactor)
                  yasara.ColorRes(res,str(color))
                id=pdb_object+pdb_molecule+str(pdbmap[name][gapmap[name][number]+1])
                tango_array.append(id)
              else:
                gap=1

            if gap==1:
              if flag_present>0:
                if gapmap[name][start-1]:
                  output+=solubisplotoutput.plotoutput_entries(name,"tango",start,pdbmap[name][gapmap[name][start-1]+1],line.split("\t")[2],line.split("\t")[3],line.split("\t")[4],line.split("\t")[5],"YES but not completely")
                else:
                  output+=solubisplotoutput.plotoutput_entries(name,"tango",start,"N.A",line.split("\t")[2],line.split("\t")[3],line.split("\t")[4],line.split("\t")[5],"YES but not completely")
              else:
                output+=solubisplotoutput.plotoutput_entries(name,"tango",start,"N.A.",line.split("\t")[2],line.split("\t")[3],line.split("\t")[4],line.split("\t")[5],"NO")

            else:
              output+=solubisplotoutput.plotoutput_entries(name,"tango",start,pdbmap[name][gapmap[name][start-1]+1],line.split("\t")[2],line.split("\t")[3],line.split("\t")[4],line.split("\t")[5],"YES")
          elif re.match(r"Obj(\d+)Mol",name):
            yasara.plugin.end("To calculate, all molecules in the object should have unique names. Please rename all nameless molecules with Edit > Rename")
    else:
      output+="No tango stretches in this molecule\n"
  return(tango_array,output)

def WriteTango(cachedir,agadirbin,temperature,ph,ionicstrength,Tfecon,stability,concentration):
  file=open(os.path.join(cachedir,"all_seq.tab"),"r")
  tango_command=open(os.path.join(cachedir,"tango.sh"),"w")
  for line in file:
    line.rstrip('\n')
    name=line.split("\t")[0]
    seq=line.split("\t")[1].rstrip('\n')
    if (yasara.opsys=='Windows'):
      tango_command.write(agadirbin+" "+name+" nt='N' ct='N' ph="+str(ph)+" te="+str(temperature)+" io="+str(ionicstrength)+" tf="+str(Tfecon)+" stab="+str(stability)+" seq="+seq+"\n")
    if (yasara.opsys!='Windows'):
      tango_command.write(agadirbin+" "+name+" nt='N' ct='N' ph="+str(ph)+" te="+str(temperature)+" io="+str(ionicstrength)+" tf="+str(Tfecon)+" stab="+str(stability)+" seq="+seq+" > "+os.path.join(cachedir,name)+".txt\n")
  tango_command.close()

def create_windowsfile(cachedir,tangowintresh,tangominsize,tangoflanksize):
  seq=open(os.path.join(cachedir,"all_seq.tab"),"r")
  tango_window=open(os.path.join(cachedir,"tangowindow.out"),"w")
  for line in seq:
    line.rstrip()
    name=line.split("\t")[0]
    seq=line.split("\t")[1]
    flag=0
    count=0
    tango_output=open(os.path.join(cachedir,name+'.txt'),"r")
    for line in tango_output:
      count=count+1
      if count>1:
        tmp=line.split("\t")
        tangoscore=float(tmp[5].strip(' '))
        ##begin of zone
        if(flag==0 and tangoscore>=tangowintresh):
          flag=1
          windowbegin=int(tmp[0].strip(' '))
          tangoscore_tmp=tangoscore
        #continue zone
        elif(flag==1 and tangoscore>=tangowintresh):
          tangoscore_tmp+=tangoscore
        #end of zone
        elif(flag==1 and tangoscore<tangowintresh):
          windowend=int(tmp[0].strip(' '))-1
          length=windowend-windowbegin+1
          if length>=tangominsize:
            #make sequence
            gkbegin=windowbegin-tangoflanksize
            if(gkbegin<0):gkbegin=0
            gkend=windowend+tangoflanksize
            if(gkend>len(seq)):gkend=len(seq) ## ??? how to check length of sequence molecule!!!!???? ?? how to retrieve sequence???
                        
            norm_tango=tangoscore_tmp/length
            tango_window.write(name+'\t'+str(windowbegin)+'\t'+seq[gkbegin-1:windowbegin-1]+'\t'+seq[windowbegin-1:windowend]+'\t'+seq[windowend:gkend].rstrip()+'\t'+str(round(tangoscore_tmp,2))+'\t'+str(length)+'\n')## write out in same manner as tangowindow!!!!!
          flag=0
  tango_window.close()
