#!/usr/bin/python

import yasara,os,re,subprocess

def plotoutput_header():
  tangooutput="+-------------------------------------------------------------------------------------------------------------------------------------------------------+\n"
  tangooutput+="|ProteinName    | Predictor | Position Sequence | Position PDB | Nterm_GK |       Stretch          | Cterm_GK | Score    | Stretch present in structure?|\n"
  tangooutput+="+-------------------------------------------------------------------------------------------------------------------------------------------------------+\n"
  return(tangooutput)

def plotoutput_entries(Name,predictor,position_seq,pos_pdb,Nterm,stretch,Cterm,score,gap):
  output=""
  numnamespaces=len("ProteinName    ")-len(Name)
  numpredictorspaces=len(" Predictor ")-len(predictor)
  numposspaces=len(" Position Sequence ")-len(str(position_seq))
  numpospdbspaces=len(" Position PDB ")-len(str(pos_pdb))
  numNtermspaces=len(" Nterm_GK ")-len(Nterm)
  numstretchspaces=len("       Stretch          ")-len(stretch)
  numCtermspaces=len(" Cterm_GK ")-len(Cterm)
  numScorespaces=len(" Score    ")-len(score)
  numgapspaces=len(' Stretch present in structure?')-len(gap)
  namespaces = ""
  for i in range(numnamespaces):
    namespaces += " "
  predspaces=""
  for i in range(numpredictorspaces):
    predspaces+=" "
  posspaces = ""
  for i in range(numposspaces):
    posspaces += " "
  pospdbspaces = ""
  for i in range(numpospdbspaces):
    pospdbspaces += " "
  Ntermspaces = ""
  for i in range(numNtermspaces):
    Ntermspaces += " "
  stretchspaces = ""
  for i in range(numstretchspaces):
    stretchspaces += " "
  Ctermspaces = ""
  for i in range(numCtermspaces):
    Ctermspaces += " "
  Scorespaces = ""
  for i in range(numScorespaces):
    Scorespaces += " "
  gapspaces=""
  for i in range(numgapspaces):
    gapspaces +=" "
  output+=  "|"+Name+namespaces+"|"+predictor+predspaces+"|"+str(position_seq)+posspaces+"|"+str(pos_pdb)+pospdbspaces+"|"+Nterm+Ntermspaces+"|"+stretch+stretchspaces+"|"
  output+= Cterm+Ctermspaces+"|"+score+Scorespaces+"|"+gap+gapspaces+"|\n"
  output+="+-------------------------------------------------------------------------------------------------------------------------------------------------------+\n"
  return(output)

def plot_header_solubis():
  output="+--------------------------------------------------------------------------------------------------+\n"
  output+="| Name      | Mutation_SEQ    | Mutation_PDB    | TANGO difference   | ddG   | SOLUBIS mutant?     |\n";
  output+="+-------------------------------------------------------------------------------------------------+\n"
  return(output)

def plot_solubis_entries(Name, Mutation_seq,Mutation_pdb,tango_diff,ddg,label):
  output=""
  numnamespace=len(" Name      ")-len(Name)
  nummutspace_seq=len(" Mutation_SEQ    ")-len(Mutation_seq)
  nummutspace_pdb=len(" Mutation_PDB    ")-len(Mutation_pdb)
  numtdifspace=len(" TANGO difference   ")-len(str(round(tango_diff,2)))
  numddgspace=len(" ddG   ")-len(str(ddg))
  numlabelspace=len(" SOLUBIS mutant?     ")-len(label)
  namespaces = ""
  for i in range(numnamespace):
    namespaces += " "
  mutspaces_seq=""
  for i in range(nummutspace_seq):
    mutspaces_seq+=" "
  mutspaces_pdb=""
  for i in range(nummutspace_pdb):
    mutspaces_pdb+=" "
  tdifspaces = ""
  for i in range(numtdifspace):
    tdifspaces += " "
  ddgspaces = ""
  for i in range(numddgspace):
    ddgspaces += " "
  labelspaces = ""
  for i in range(numlabelspace):
    labelspaces += " "

  output+=  "|"+Name+namespaces+"|"+Mutation_seq+mutspaces_seq+"|"+Mutation_pdb+mutspaces_pdb+"|"+str(round(tango_diff,2))+tdifspaces+"|"+str(ddg)+ddgspaces+"|"+label+labelspaces+"|\n"

  output+="+-------------------------------------------------------------------------------------------------+\n"
  return(output)

def write_outputfile(cachedir,filecontent):
  output=open(os.path.join(cachedir,"SOLUBIS_SUMMARY.out"),"a")
  output.write(filecontent)
  output.close()

def write_outputfile_table(cachedir,filecontent):
  output=open(os.path.join(cachedir,"SOLUBIS_SUMMARY_TABLE.out"),"a")
  output.write(filecontent)
  output.close()
